


c-------------------------------------------------------------------

c --> calculation of unphysical parameters from physical stop/sbot parameters
      subroutine def5(tb,mt,mw,mz,mst1,mst2,stt,msbotr, xb,
     $                msusytl,msusytr,msusybl,msusybr,mtlr,mblr)

      double precision mst1,mst2,stt,ctt
      double precision msusytl,msusytr,msusybl,msusybr,mtlr,mblr,
     $                 msusytl2, msusytr2, msbotr, xb
      double precision mw,mz,mt,tb,b,c2b,sw2,dt1,dt2
      double precision rot(1:2,1:2), rottrans(1:2,1:2), 
     $                 mdiag(1:2,1:2), mnondiag(1:2,1:2), z(1:2,1:2)

c      write(*,*) 'Parameters in def5:'
c      write(*,*) real(tb), real(mt), real(mw), real(mz), real(mst1),
c     $           real(mst2), real(stt), real(msbotr), real(xb)

      b = datan(tb)
      c2b = dcos(2d0*b)
      sw2 = 1d0 - mw**2/mz**2
      dt1 = mz**2 * c2b * (.5d0 - 2d0/3d0 * sw2)
      dt2 = mz**2 * c2b * (       2d0/3d0 * sw2)

      mdiag(1,1) = mst1**2
      mdiag(1,2) = 0d0
      mdiag(2,1) = 0d0
      mdiag(2,2) = mst2**2
      ctt = dsqrt(1d0 - stt**2)
      rot(1,1) = ctt
      rot(1,2) = stt
      rot(2,1) = -stt
      rot(2,2) = ctt
      rottrans(1,1) = ctt
      rottrans(1,2) = -stt
      rottrans(2,1) = stt
      rottrans(2,2) = ctt

      call diagonalization(rottrans, mdiag, rot, mnondiag)
c      write(*,*) 'after diagonalization'
 
      msusytl2 = mnondiag(1,1) - mt**2 - dt1
      msusytr2 = mnondiag(2,2) - mt**2 - dt2
      if ((msusytl2.ge.0d0).and.(msusytr2.ge.0d0)) then
         msusytl = dsqrt(mnondiag(1,1) - mt**2 - dt1)
         msusytr = dsqrt(mnondiag(2,2) - mt**2 - dt2)
         msusybl = msusytl
         msusybr = msbotr
         mtlr = mnondiag(1,2)/mt
         mblr = xb
      else
         msusytl = 0d0
         msusytr = 0d0
         msusybl = 0d0
         msusybr = 0d0
         mtlr = 0d0
         mblr = 0d0
      endif
c      write(*,*) 'def5 completed'

      end
